.586
.MODEL FLAT, stdcall
option casemap:none

include c:\masm32\include\windows.inc

include c:\masm32\include\kernel32.inc
include c:\masm32\include\user32.inc
include c:\masm32\include\masm32.inc
include c:\masm32\include\msvcrt.inc

include c:\masm32\macros\macros.asm

includelib c:\masm32\lib\kernel32.lib
includelib c:\masm32\lib\user32.lib
includelib c:\masm32\lib\masm32.lib
includelib c:\masm32\lib\msvcrt.lib

;; ----------------------------------------------
ubyte$ MACRO ubytevalue:req
    ; unsigned byte
    LOCAL buffer
    .data?
        buffer BYTE 4 dup(?)
    IFNDEF ubfmt    
    .data    
        ubfmt  BYTE "%hhu", 0
    ENDIF    
    .code
        mov   al, ubytevalue
        movzx eax, al
        push  eax
        push  OFFSET ubfmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 12
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
sbyte$ MACRO sbytevalue:req
    ; signed byte
    LOCAL buffer
    .data?
        buffer BYTE 8 dup(?)
    IFNDEF sbfmt     
    .data    
        sbfmt  BYTE "%hhd", 0
    ENDIF    
    .code
        mov   al, sbytevalue
        movsx eax, al
        push  eax
        push  OFFSET sbfmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 12
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
xbyte$ MACRO xbytevalue:req
    ; unsigned hex byte
    LOCAL buffer
    .data?
        buffer BYTE 4 dup(?)
    IFNDEF xbfmt    
    .data    
        xbfmt  BYTE "%hhX", 0
    ENDIF    
    .code
        mov   al, xbytevalue
        movzx eax, al
        push  eax
        push  OFFSET xbfmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 12
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
uword$ MACRO uwordvalue:req
    ; unsigned word
    LOCAL buffer
    .data?
        buffer BYTE 8 dup(?)
    IFNDEF uwfmt    
    .data    
        uwfmt  BYTE "%hu", 0
    ENDIF    
    .code
        mov   ax, uwordvalue
        movzx eax, ax
        push  eax
        push  OFFSET uwfmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 12
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
sword$ MACRO swordvalue:req
    ; signed word
    LOCAL buffer
    .data?
        buffer BYTE 8 dup(?)
    IFNDEF swfmt    
    .data    
        swfmt  BYTE "%hd", 0
    ENDIF    
    .code
        mov   ax, swordvalue
        movsx eax, ax
        push  eax
        push  OFFSET swfmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 12
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
xword$ MACRO xwordvalue:req
    ; unsigned hex word
    LOCAL buffer
    .data?
        buffer BYTE 8 dup(?)
    IFNDEF xwfmt    
    .data    
        xwfmt  BYTE "%hX", 0
    ENDIF    
    .code
        mov   ax, xwordvalue
        movzx eax, ax
        push  eax
        push  OFFSET xwfmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 12
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
udword$ MACRO udwordvalue:req
    ; unsigned dword
    LOCAL buffer
    .data?
        buffer BYTE 12 dup(?)
    IFNDEF udwfmt    
    .data    
        udwfmt BYTE "%lu", 0
    ENDIF    
    .code
        push  udwordvalue
        push  OFFSET udwfmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 12
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
sdword$ MACRO sdwordvalue:req
    ; signed dword
    LOCAL buffer
    .data?
        buffer BYTE 12 dup(?)
    IFNDEF sdwfmt    
    .data    
        sdwfmt    BYTE "%ld", 0
    ENDIF    
    .code
        push  sdwordvalue
        push  OFFSET sdwfmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 12
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
xdword$ MACRO xdwordvalue:req
    ; unsigned hex dword
    LOCAL buffer
    .data?
        buffer BYTE 12 dup(?)
    IFNDEF xdwfmt    
    .data    
        xdwfmt BYTE "%lX", 0
    ENDIF    
    .code
        push  xdwordvalue
        push  OFFSET xdwfmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 12
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
uqword$ MACRO uqwordvalue:req
    ; unsigned qword
    LOCAL buffer
    .data?
        buffer BYTE 24 dup(?)
    IFNDEF uqwfmt    
    .data    
        uqwfmt BYTE "%I64u", 0
    ENDIF    
    .code
        push  DWORD PTR [uqwordvalue+4]
        push  DWORD PTR [uqwordvalue+0]
        push  OFFSET uqwfmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 16
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
sqword$ MACRO sqwordvalue:req
    ; signed qword
    LOCAL buffer
    .data?
        buffer BYTE 24 dup(?)
    IFNDEF sqwfmt    
    .data    
        sqwfmt BYTE "%I64d", 0
    ENDIF    
    .code
        push  SDWORD PTR [sqwordvalue+4]
        push  DWORD PTR  [sqwordvalue+0]
        push  OFFSET sqwfmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 16
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
xqword$ MACRO xqwordvalue:req
    ; unsigned hex qword
    LOCAL buffer
    .data?
        buffer BYTE 20 dup(?)
    IFNDEF xqwfmt    
    .data    
        xqwfmt    BYTE "%I64X", 0
    ENDIF    
    .code
        push  DWORD PTR [xqwordvalue+4]
        push  DWORD PTR [xqwordvalue+0]
        push  OFFSET xqwfmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 16
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
real4$ MACRO r4value:req
    LOCAL r8value, buffer
    .data?
        r8value REAL8 ?
        buffer  BYTE  52 dup(?)
    IFNDEF r8fmt    
    .data
        r8fmt   BYTE "%lf", 0
    ENDIF    
    .code
        finit
        fld   r4value
        fstp  r8value
        fwait
        push  DWORD PTR [r8value+4]
        push  DWORD PTR [r8value+0]
        push  OFFSET r8fmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 16
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
real8$ MACRO r8value:req
    LOCAL buffer
    .data?
        buffer BYTE 320 dup(?)
    IFNDEF r8fmt    
    .data    
        r8fmt  BYTE "%lf", 0
    ENDIF    
    .code
        push  DWORD PTR [r8value+4]
        push  DWORD PTR [r8value+0]
        push  OFFSET r8fmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 16
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
real10$ MACRO r10value:req
    LOCAL r8value, buffer
    .data?
        r8value REAL8 ?
        buffer  BYTE  320 dup(?)
    IFNDEF r8fmt    
    .data    
        r8fmt   BYTE "%lf", 0
    ENDIF    
    .code
        finit
        fld   r10value
        fstp  r8value
        fwait
        push  DWORD PTR [r8value+4]
        push  DWORD PTR [r8value+0]
        push  OFFSET r8fmt
        push  OFFSET buffer
        call  crt_sprintf
        add   esp, 16
    EXITM <OFFSET buffer>
ENDM
;; ----------------------------------------------
WaitKey MACRO
    LOCAL crlf, pak
    .data
        crlf BYTE 13, 10, 0
        pak  BYTE 13, 10, "Press any key to continue...", 0
    .code    
        push OFFSET pak
        call crt_printf
        add esp, 4
        call crt__getch
        .if (eax == 0) || (eax == 0E0h)
            call crt__getch
        .endif 
        push OFFSET crlf
        call crt_printf
        add esp, 4
ENDM
;; ----------------------------------------------

.DATA
        
    ubyMax BYTE   255                        ; UCHAR_MAX
    ubyMin BYTE     0                        ; UCHAR_MIN
    
    sbyMax SBYTE  127                        ; CHAR_MAX
    sbyMin SBYTE -128                        ; CHAR_MIN
    
    uwdMax WORD   65535                      ; USHRT_MAX
    uwdMin WORD       0                      ; USHRT_MIN
    
    swdMax SWORD  32767                      ; SHRT_MAX
    swdMin SWORD -32768                      ; SHRT_MIN
    
    udwMax DWORD   4294967295                ; ULONG MAX
    udwMin DWORD            0                ; ULONG_MIN
    
    sdwMax SDWORD  2147483647                ; LONG_MAX
    sdwMin SDWORD -2147483647 - 1            ; LONG_MIN
    
    uqwMax QWORD 18446744073709551615        ; _UI64_MAX
    uqwMin QWORD                    0        ; _UI64_MIN
    
    sqwMax QWORD  9223372036854775807        ; _I64_MAX
    sqwMin QWORD -9223372036854775807 - 1    ; _I64_MIN
    
    r4Max  REAL4   3.402823466E+38           ; FLT_MAX
    r4Min  REAL4  -1.175494351E-38           ; FLT_MIN
    
    r8Max  REAL8   1.7976931348623158E+308   ; DBL_MAX
    r8Min  REAL8  -2.2250738585072014E-308   ; DBL_MIN
    
    r10Max REAL10  1.7976931348623158E+308   ; LDBL_MAX ( = DBL_MAX)
    r10Min REAL10 -2.2250738585072014E-308   ; LDBL_MIN ( = DBL_MIN)
        
.CODE

start:
        
    invoke crt_puts, ubyte$(ubyMax)
    invoke crt_puts, ubyte$(ubyMin)
    invoke crt_puts, SADD(0)
    invoke crt_puts, sbyte$(sbyMax)
    invoke crt_puts, sbyte$(sbyMin)
    invoke crt_puts, SADD(0)
    invoke crt_puts, xbyte$(ubyMax)
    invoke crt_puts, xbyte$(ubyMin)
    invoke crt_puts, SADD(0)
    invoke crt_puts, uword$(uwdMax)
    invoke crt_puts, uword$(uwdMin)
    invoke crt_puts, SADD(0)
    invoke crt_puts, sword$(swdMax)
    invoke crt_puts, sword$(swdMin)
    invoke crt_puts, SADD(0)
    invoke crt_puts, xword$(uwdMax)
    invoke crt_puts, xword$(uwdMin)
    invoke crt_puts, SADD(0)
    invoke crt_puts, udword$(udwMax)
    invoke crt_puts, udword$(udwMin)
    invoke crt_puts, SADD(0)
    invoke crt_puts, sdword$(sdwMax)
    invoke crt_puts, sdword$(sdwMin)
    invoke crt_puts, SADD(0)
    invoke crt_puts, xdword$(udwMax)
    invoke crt_puts, xdword$(udwMin)
    invoke crt_puts, SADD(0)
    invoke crt_puts, uqword$(uqwMax)
    invoke crt_puts, uqword$(uqwMin)
    invoke crt_puts, SADD(0)
    invoke crt_puts, sqword$(sqwMax)
    invoke crt_puts, sqword$(sqwMin)
    invoke crt_puts, SADD(0)
    invoke crt_puts, xqword$(uqwMax)
    invoke crt_puts, xqword$(uqwMin)
    invoke crt_puts, SADD(0)
    invoke crt_puts, real4$(r4Max)
    invoke crt_puts, real4$(r4Min)
    invoke crt_puts, SADD(0)
    invoke crt_puts, real8$(r8Max)
    invoke crt_puts, real8$(r8Min)
    invoke crt_puts, SADD(0)
    invoke crt_puts, real10$(r10Max)
    invoke crt_puts, real10$(r10Min)
            
    WaitKey
         
    invoke ExitProcess, 0

end start 
